<?php

namespace Goal\Goal;

use User;

class Goal
{
    /**
     * $goal object.
     */
    protected $goal;

    /**
     * Constructor.
     */
    public function __construct(\Goal\Goal\Interfaces\GoalRepositoryInterface $goal)
    {
        $this->goal = $goal;
    }

    /**
     * Returns count of goal.
     *
     * @param array $filter
     *
     * @return int
     */
    public function count()
    {
        return  0;
    }

    /**
     * Make gadget View
     *
     * @param string $view
     *
     * @param int $count
     *
     * @return View
     */
    public function gadget($view = 'admin.goal.gadget', $count = 10)
    {

        if (User::hasRole('user')) {
            $this->goal->pushCriteria(new \Litepie\Goal\Repositories\Criteria\GoalUserCriteria());
        }

        $goal = $this->goal->scopeQuery(function ($query) use ($count) {
            return $query->orderBy('id', 'DESC')->take($count);
        })->all();

        return view('goal::' . $view, compact('goal'))->render();
    }
}
