<?php

namespace Goal\Goal\Http\Controllers;

use App\Http\Controllers\PublicController as BaseController;
use Goal\Goal\Interfaces\GoalRepositoryInterface;

class GoalPublicController extends BaseController
{
    // use GoalWorkflow;

    /**
     * Constructor.
     *
     * @param type \Goal\Goal\Interfaces\GoalRepositoryInterface $goal
     *
     * @return type
     */
    public function __construct(GoalRepositoryInterface $goal)
    {
        $this->repository = $goal;
        parent::__construct();
    }

    /**
     * Show goal's list.
     *
     * @param string $slug
     *
     * @return response
     */
    protected function index()
    {
        $goals = $this->repository
        ->pushCriteria(app('Litepie\Repository\Criteria\RequestCriteria'))
        ->scopeQuery(function($query){
            return $query->orderBy('id','DESC');
        })->paginate();

        return $this->theme->of('goal::public.goal.index', compact('goals'))->render();
    }

    /**
     * Show goal.
     *
     * @param string $slug
     *
     * @return response
     */
    protected function show($slug)
    {
        $goal = $this->repository->scopeQuery(function($query) use ($slug) {
            return $query->orderBy('id','DESC')
                         ->where('slug', $slug);
        })->first(['*']);

        return $this->theme->of('goal::public.goal.show', compact('goal'))->render();
    }

}
