<?php

namespace Goal\Goal\Workflow;

use Goal\Goal\Models\Goal;
use Goal\Goal\Notifications\Goal as GoalNotifyer;
use Notification;

class GoalNotification
{

    /**
     * Send the notification to the users after complete.
     *
     * @param Goal $goal
     *
     * @return void
     */
    public function complete(Goal $goal)
    {
        return Notification::send($goal->user, new GoalNotifyer($goal, 'complete'));;
    }

    /**
     * Send the notification to the users after verify.
     *
     * @param Goal $goal
     *
     * @return void
     */
    public function verify(Goal $goal)
    {
        return Notification::send($goal->user, new GoalNotifyer($goal, 'verify'));;
    }

    /**
     * Send the notification to the users after approve.
     *
     * @param Goal $goal
     *
     * @return void
     */
    public function approve(Goal $goal)
    {
        return Notification::send($goal->user, new GoalNotifyer($goal, 'approve'));;

    }

    /**
     * Send the notification to the users after publish.
     *
     * @param Goal $goal
     *
     * @return void
     */
    public function publish(Goal $goal)
    {
        return Notification::send($goal->user, new GoalNotifyer($goal, 'publish'));;
    }

    /**
     * Send the notification to the users after archive.
     *
     * @param Goal $goal
     *
     * @return void
     */
    public function archive(Goal $goal)
    {
        return Notification::send($goal->user, new GoalNotifyer($goal, 'archive'));;

    }

    /**
     * Send the notification to the users after unpublish.
     *
     * @param Goal $goal
     *
     * @return void
     */
    public function unpublish(Goal $goal)
    {
        return Notification::send($goal->user, new GoalNotifyer($goal, 'unpublish'));;

    }
}
